"""
This does the full thing:  it views from the retina, through V1,
to pyramid detection, then sets a fact on.  It also has the planning in.
So, it does the commands that are activated. 
I haven't done a good range of error checking for planning or pictures.
It runs on a 4 chip spinnaker board with 3-1 neurons.
Set this in nealParams.py.
"""

#imports for PyNN
from pyNN.utility import get_script_args#, normalized_filename
#from neo.io import PyNNTextIO

#import for spike injection
import spynnaker_external_devices_plugin.pyNN as externaldevices
from spinnman.messages.eieio.eieio_prefix_type import EIEIOPrefixType

#imports for image reading
import numpy
from PIL import Image

#NEAL files and functions
from nealParams import *
from visionClass import visionArea
from maesSpinnV12 import *
from parseClass import parseArea
from controlClass import controlArea


SUB_POPULATION_SIZE	=	5			#size of sub population



def nealProjection(preNeurons,postNeurons, connectorList,inhExc):
    if simulator_name == 'spiNNaker':
        Projection(preNeurons, postNeurons, connectorList,target=inhExc)
    elif simulator_name == 'nest':
        Projection(preNeurons, postNeurons, connectorList)
    else:
        print 'bad simulator for nealProjection'

def runNoCallBack():
    run(SIM_LENGTH)

def connectVisionFactToPlanFact(visionFactNumber, planFactNumber):
    connector = []
    wt = 4.0
    for inpOffset in range (0,5):
        inpNeuron = inpOffset + visionFactNumber*5
        for toOffset in range (0,5):
            toNeuron = toOffset + (planFactNumber*5)
            connector = connector + [(inpNeuron,toNeuron,wt,DELAY)]
    return connector

def connectVisionToPlan():
    print "cvp"
    #Connect Vision Facts to Plan Facts
    visionFactCells = vision.getVisionFactCells()
    #visionFactRightPyramid = vision.getRightPyramid()
    #visionFactLeftPyramid = vision.getLeftPyramid()
    #visionFactRightStalactite = vision.getRightStalactite()
    #visionFactLeftStalactite = vision.getLeftStalactite()
    maesFacts = maes1.getFactPop()
    #leftpyr to left
    connectors = connectVisionFactToPlanFact(0,maes1.getFactIndex('LEFT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightpyr to right
    connectors = connectVisionFactToPlanFact(1,maes1.getFactIndex('RIGHT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftpyr to pyr
    connectors = connectVisionFactToPlanFact(0,maes1.getFactIndex('PYR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightpyr to pyr
    connectors = connectVisionFactToPlanFact(1,maes1.getFactIndex('PYR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftstal to left
    connectors = connectVisionFactToPlanFact(2,maes1.getFactIndex('LEFT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftstal to stal
    connectors = connectVisionFactToPlanFact(2,maes1.getFactIndex('STAL')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightstal to right
    connectors = connectVisionFactToPlanFact(3,maes1.getFactIndex('RIGHT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightstal to stal
    connectors = connectVisionFactToPlanFact(3,maes1.getFactIndex('STAL')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrepyr to pyr
    connectors = connectVisionFactToPlanFact(4,maes1.getFactIndex('PYR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrepyr to centre
    connectors = connectVisionFactToPlanFact(4,maes1.getFactIndex('CENTRE')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrestal to stal
    connectors = connectVisionFactToPlanFact(5,maes1.getFactIndex('STAL')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centrestal to centre
    connectors = connectVisionFactToPlanFact(5,maes1.getFactIndex('CENTRE')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftdoor to left
    connectors = connectVisionFactToPlanFact(6,maes1.getFactIndex('LEFT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #leftdoor to door
    connectors = connectVisionFactToPlanFact(6,maes1.getFactIndex('DOOR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centredoor to centre
    connectors = connectVisionFactToPlanFact(7,maes1.getFactIndex('CENTRE')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #centredoor to door
    connectors = connectVisionFactToPlanFact(7,maes1.getFactIndex('DOOR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightdoor to right
    connectors = connectVisionFactToPlanFact(8,maes1.getFactIndex('RIGHT')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')

    #rightdoor to door
    connectors = connectVisionFactToPlanFact(8,maes1.getFactIndex('DOOR')) 
    connList = FromListConnector(connectors)
    nealProjection(visionFactCells,maesFacts,connList,'excitatory')



def connectParseResultToGoal(parseCells,goalCells,parseNumber,goalNumber):
    connectors = []
    wt = 10.0 #4chip
    for fromNeuron in range (0,5):
        inpNeuron = parseNumber*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = goalNumber*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    excConnector = FromListConnector(connectors)
    nealProjection(parseCells, goalCells, excConnector,'excitatory')

#Bump is sent by the environment to word 20.
#If that fires, turn the plan bump fact on.
def connectParseBumpToFact():
    parseBumpCells = parse.getBumpFromEnv()
    maesFactCells = maes1.getFactPop()
    bumpIndex=maes1.getFactIndex("BUMP")
    spbi = bumpIndex * SUB_POPULATION_SIZE
    wt = 25.0
    connectors=[]
    for toNeuron in range (0,5):
        outNeuron = spbi + toNeuron
        connectors = connectors + [(22,outNeuron,wt,DELAY)]
    excConnector = FromListConnector(connectors)
    nealProjection(parseBumpCells, maesFactCells, excConnector,'excitatory')

def connectParseToPlan():
    stateUnits = parse.getStates()
    goalUnits = maes1.getGoalCells()
    #turn left
    connectParseResultToGoal(stateUnits,goalUnits,3,maes1.getGoalIndex("TL")) 
    #turn right
    connectParseResultToGoal(stateUnits,goalUnits,5,maes1.getGoalIndex("TR")) 
    #move forward
    connectParseResultToGoal(stateUnits,goalUnits,14,maes1.getGoalIndex("FW")) 
    #move back
    connectParseResultToGoal(stateUnits,goalUnits,16,maes1.getGoalIndex("BW")) 
    #move left
    connectParseResultToGoal(stateUnits,goalUnits,18,maes1.getGoalIndex("ML1"))
    #move right
    connectParseResultToGoal(stateUnits,goalUnits,20,maes1.getGoalIndex("MR1"))
    #turn toward the pyramid
    connectParseResultToGoal(stateUnits,goalUnits,9,maes1.getGoalIndex("TP")) 
    #turn toward the stalac
    connectParseResultToGoal(stateUnits,goalUnits,11,maes1.getGoalIndex("TS"))
    #go to the barred pyram
    connectParseResultToGoal(stateUnits,goalUnits,49,maes1.getGoalIndex("GP"))
    #go to the barred stal
    connectParseResultToGoal(stateUnits,goalUnits,51,maes1.getGoalIndex("GS"))
    #go to the door
    connectParseResultToGoal(stateUnits,goalUnits,41,maes1.getGoalIndex("GD"))
    connectParseBumpToFact()

def oneParseMovesOneControl(parseCells,controlCells,parseCA,newControlCA):
    connectors = []
    #wt = 0.03 #4 chip
    wt = 0.3
    for fromNeuron in range (0,5):
        inpNeuron = parseCA*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = newControlCA*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    excConnector = FromListConnector(connectors)
    nealProjection(parseCells, controlCells, excConnector,'excitatory')


def oneControlStopsOneParse(parseCells,controlCells,parseCA,controlCA):
    connectors = []
    wt = -25.0
    for fromNeuron in range (0,5):
        inpNeuron = controlCA*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = parseCA*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    inhConnector = FromListConnector(connectors)
    nealProjection(controlCells, parseCells, inhConnector,'inhibitory')

def oneControlStartsOneParse(parseCells,controlCells,parseCA,controlCA):
    connectors = []
    wt = 2.0
    for fromNeuron in range (0,5):
        inpNeuron = controlCA*5 + fromNeuron
        for toNeuron in range (0,5):
            outNeuron = parseCA*5 + toNeuron
            connectors = connectors + [(inpNeuron,outNeuron,wt,DELAY)]
    inhConnector = FromListConnector(connectors)
    nealProjection(controlCells, parseCells, inhConnector,'excitatory')

def connectParseAndControl():
    #consider does it need to start first parse state to parse again?
    parseUnits = parse.getStates()
    controlUnits = control.getStates()
    for parseState in (3,5,9,11,14,16,18,20,41,49): #final parse states
        oneParseMovesOneControl(parseUnits,controlUnits,parseState,1)
        oneControlStopsOneParse(parseUnits,controlUnits,parseState,1)
    oneControlStartsOneParse(parseUnits,controlUnits,0,2)

def test():
    input = vision.getBWVisionInputCells()
    weight = 20.0
    connectors = []
    for i  in range(0,neuronsPerSubnet):
        #connectors = connectors + [(i,0,weight,DELAY)]
        connectors = connectors + [(i,i,weight,DELAY)]

    connectorList = FromListConnector(connectors) 
    nealProjection(input,testCells, connectorList,'excitatory')

    return




#------------Main Body---------------
#import the simulator via nealParams.py
#simulator_name = get_script_args(1)[0]  
#exec("from pyNN.%s import *" % simulator_name)

setup(timestep=DELAY,min_delay=DELAY,max_delay=DELAY,debug=0)

#----------------create neurons

parse = parseArea(simulator_name)
#--------------external input parse needs to be before connections 
#parse.setSpikeServerInputs()
parse.allocateParseNeurons()

vision = visionArea(simulator_name)
vision.setWhatsOn(4) #4,3,2,1=off
vision.allocateVisionNeurons()

maes1 = Maes()

control = controlArea()
control.allocateControlNeurons()
 
#--------------external input parse needs to be before connections 
#parse.setInputs()

#---------setup connections
vision.makeVisionSynapses()
maes1.networkFromCSV("network_cabot3_1.dat")
parse.setConnections()

spikes = [[7]]
controlInputSource=Population(1,SpikeSourceArray,{'spike_times':spikes})
control.makeControlSynapses(controlInputSource)

#connect subsytems
connectVisionToPlan()
connectParseToPlan()
connectParseAndControl()

cell_params = {'tau_refrac' : 3.0, 'v_rest' : -65.0, 'v_thresh' : -51.0,  'tau_syn_E'  : 2.0, 'tau_syn_I': 5.0,    'v_reset'    : -70.0,  'i_offset' : 0.1}
testCells=Population(neuronsPerSubnet, IF_curr_exp, cell_params)
testCells.record()
test()

#-------------------setup recording
vision.setVisionRecording()
maes1.setPlanRecording()
parse.setRecording()
control.setControlRecording()

runNoCallBack()

#--------------print results
print "done running"

vision.printVisionNets()
#vision.printObjects()
#threeOffCells.printSpikes("results/toc.sp")
maes1.printMaes() 
parse.printResults()
control.printControlNets()

testCells.printSpikes('results/test.sp')

end()

